Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
BulletWheel Class Reference

One wheel of a BulletVehicle. More...

`#include "bulletWheel.h"`

## Public Member Functions
| BulletWheel (btWheelInfo &info)
PN_stdfloat | get_brake () const
LPoint3 | get_chassis_connection_point_cs () const
PN_stdfloat | get_clipped_inv_connection_point_cs () const
PN_stdfloat | get_delta_rotation () const
PN_stdfloat | get_engine_force () const
PN_stdfloat | get_friction_slip () const
PN_stdfloat | get_max_suspension_force () const
PN_stdfloat | get_max_suspension_travel_cm () const
PandaNode * | get_node () const
BulletWheelRaycastInfo | get_raycast_info () const
PN_stdfloat | get_roll_influence () const
PN_stdfloat | get_rotation () const
PN_stdfloat | get_skid_info () const
PN_stdfloat | get_steering () const
PN_stdfloat | get_suspension_relative_velocity () const
PN_stdfloat | get_suspension_rest_length () const
PN_stdfloat | get_suspension_stiffness () const
LVector3 | get_wheel_axle_cs () const
LVector3 | get_wheel_direction_cs () const
PN_stdfloat | get_wheel_radius () const
PN_stdfloat | get_wheels_damping_compression () const
PN_stdfloat | get_wheels_damping_relaxation () const
PN_stdfloat | get_wheels_suspension_force () const
LMatrix4 | get_world_transform () const
bool | is_front_wheel () const
void | set_brake (PN_stdfloat value)
void | set_chassis_connection_point_cs (const LPoint3 &pos)
void | set_clipped_inv_connection_point_cs (PN_stdfloat value)
void | set_delta_rotation (PN_stdfloat value)
void | set_engine_force (PN_stdfloat value)
void | set_friction_slip (PN_stdfloat value)
void | set_front_wheel (bool value)
void | set_max_suspension_force (PN_stdfloat value)
void | set_max_suspension_travel_cm (PN_stdfloat value)
void | set_node (PandaNode *node)
void | set_roll_influence (PN_stdfloat value)
void | set_rotation (PN_stdfloat value)
void | set_skid_info (PN_stdfloat value)
void | set_steering (PN_stdfloat value)
void | set_suspension_relative_velocity (PN_stdfloat value)
void | set_suspension_stiffness (PN_stdfloat value)
void | set_wheel_axle_cs (const LVector3 &axle)
void | set_wheel_direction_cs (const LVector3 &dir)
void | set_wheel_radius (PN_stdfloat value)
void | set_wheels_damping_compression (PN_stdfloat value)
void | set_wheels_damping_relaxation (PN_stdfloat value)
void | set_wheels_suspension_force (PN_stdfloat value)
void | set_world_transform (const LMatrix4 &mat)

## Static Public Member Functions
static BulletWheel | empty ()
| Named constructor intended to be used for asserts with have to return a concrete value.

## Public Attributes
| get_brake
| Returns the amount of braking force currently applied.
| get_chassis_connection_point_cs
| Returns the point where the wheel is connected to the chassis.
| get_clipped_inv_connection_point_cs
| get_delta_rotation
| get_engine_force
| Returns the amount of accelleration force currently applied.
| get_friction_slip
| Returns how slippery the tyres are.
| get_max_suspension_force
| Returns the maximum force (weight) the suspension can handle.
| get_max_suspension_travel_cm
| get_node
| Returns the PandaNode which representates the visual appearance of this wheel, if such a representation has been set previously.
| get_raycast_info
| get_roll_influence
| Returns the factor by which roll forces are scaled.
| get_rotation
| get_skid_info
| get_steering
| Returns the steering angle in degrees.
| get_suspension_relative_velocity
| get_suspension_rest_length
| Returns the length of the suspension when the vehicle is standing still.
| get_suspension_stiffness
| Returns the stiffness of the suspension.
| get_wheel_axle_cs
| Returns the normal vector of the wheel axle.
| get_wheel_direction_cs
| Returns the wheel's forward vector relative to the chassis.
| get_wheel_radius
| Returns the wheel radius.
| get_wheels_damping_compression
| Returns the damping applied to the compressing suspension.
| get_wheels_damping_relaxation
| Returns the damping applied to the relaxing suspension.
| get_wheels_suspension_force
| get_world_transform
| is_front_wheel
| Determines if a wheel is steerable.
| set_brake
| set_chassis_connection_point_cs
| Sets the point where the wheel is connected to the chassis.
| set_clipped_inv_connection_point_cs
| set_delta_rotation
| set_engine_force
| Defines how much force should be used to rotate the wheel.
| set_friction_slip
| Sets the slipperyness of the tyre.
| set_front_wheel
| Sets if the wheel is steerable.
| set_max_suspension_force
| Sets the maximum suspension force the wheel can handle.
| set_max_suspension_travel_cm
| Sets the maximum distance the suspension can travel out of the resting position in centimeters.
| set_node
| Sets the PandaNode which representates the visual appearance of this wheel.
| set_roll_influence
| Defines a scaling factor for roll forces that affect the chassis.
| set_rotation
| set_skid_info
| set_steering
| Sets the steering angle.
| set_suspension_relative_velocity
| set_suspension_stiffness
| Sets how stiff the suspension shall be.
| set_wheel_axle_cs
| Determines the wheel axle normal vector.
| set_wheel_direction_cs
| Sets the wheel's forward vector.
| set_wheel_radius
| Sets the wheel radius.
| set_wheels_damping_compression
| Sets the damping forces applied when the suspension gets compressed.
| set_wheels_damping_relaxation
| Sets the damping forces applied when the suspension relaxes.
| set_wheels_suspension_force
| set_world_transform

## Detailed Description

One wheel of a BulletVehicle.

Instances should not be created directly but using the factory method BulletVehicle::create_wheel().

Definition at line 62 of file bulletWheel.h.

## Constructor & Destructor Documentation

## ◆ ~BulletWheel()

BulletWheel::~BulletWheel | ( |  | ) |
| inline

Definition at line 17 of file bulletWheel.I.

## ◆ BulletWheel()

BulletWheel::BulletWheel | ( | btWheelInfo & | info | ) |

Definition at line 21 of file bulletWheel.cxx.

## Member Function Documentation

## ◆ empty()

BulletWheel BulletWheel::empty | ( |  | ) |
| static

Named constructor intended to be used for asserts with have to return a concrete value.

Definition at line 30 of file bulletWheel.cxx.

## Member Data Documentation

## ◆ get_brake

PN_stdfloat BulletWheel::get_brake

Returns the amount of braking force currently applied.

Definition at line 131 of file bulletWheel.h.

## ◆ get_chassis_connection_point_cs

LPoint3 BulletWheel::get_chassis_connection_point_cs

Returns the point where the wheel is connected to the chassis.

Definition at line 136 of file bulletWheel.h.

## ◆ get_clipped_inv_connection_point_cs

PN_stdfloat BulletWheel::get_clipped_inv_connection_point_cs

Definition at line 135 of file bulletWheel.h.

## ◆ get_delta_rotation

PN_stdfloat BulletWheel::get_delta_rotation

Definition at line 129 of file bulletWheel.h.

## ◆ get_engine_force

PN_stdfloat BulletWheel::get_engine_force

Returns the amount of accelleration force currently applied.

Definition at line 130 of file bulletWheel.h.

## ◆ get_friction_slip

PN_stdfloat BulletWheel::get_friction_slip

Returns how slippery the tyres are.

Definition at line 121 of file bulletWheel.h.

## ◆ get_max_suspension_force

PN_stdfloat BulletWheel::get_max_suspension_force

Returns the maximum force (weight) the suspension can handle.

Definition at line 122 of file bulletWheel.h.

## ◆ get_max_suspension_travel_cm

PN_stdfloat BulletWheel::get_max_suspension_travel_cm

Definition at line 120 of file bulletWheel.h.

## ◆ get_node

PandaNode * BulletWheel::get_node

Returns the PandaNode which representates the visual appearance of this wheel, if such a representation has been set previously.

Definition at line 141 of file bulletWheel.h.

## ◆ get_raycast_info

BulletWheelRaycastInfo BulletWheel::get_raycast_info

Definition at line 117 of file bulletWheel.h.

## ◆ get_roll_influence

PN_stdfloat BulletWheel::get_roll_influence

Returns the factor by which roll forces are scaled.

See set_roll_influence.

Definition at line 125 of file bulletWheel.h.

## ◆ get_rotation

PN_stdfloat BulletWheel::get_rotation

Definition at line 128 of file bulletWheel.h.

## ◆ get_skid_info

PN_stdfloat BulletWheel::get_skid_info

Definition at line 132 of file bulletWheel.h.

## ◆ get_steering

PN_stdfloat BulletWheel::get_steering

Returns the steering angle in degrees.

Definition at line 127 of file bulletWheel.h.

## ◆ get_suspension_relative_velocity

PN_stdfloat BulletWheel::get_suspension_relative_velocity

Definition at line 134 of file bulletWheel.h.

## ◆ get_suspension_rest_length

PN_stdfloat BulletWheel::get_suspension_rest_length

Returns the length of the suspension when the vehicle is standing still.

Definition at line 118 of file bulletWheel.h.

## ◆ get_suspension_stiffness

PN_stdfloat BulletWheel::get_suspension_stiffness

Returns the stiffness of the suspension.

Definition at line 119 of file bulletWheel.h.

## ◆ get_wheel_axle_cs

LVector3 BulletWheel::get_wheel_axle_cs

Returns the normal vector of the wheel axle.

Definition at line 138 of file bulletWheel.h.

## ◆ get_wheel_direction_cs

LVector3 BulletWheel::get_wheel_direction_cs

Returns the wheel's forward vector relative to the chassis.

Definition at line 137 of file bulletWheel.h.

## ◆ get_wheel_radius

PN_stdfloat BulletWheel::get_wheel_radius

Returns the wheel radius.

Definition at line 126 of file bulletWheel.h.

## ◆ get_wheels_damping_compression

PN_stdfloat BulletWheel::get_wheels_damping_compression

Returns the damping applied to the compressing suspension.

Definition at line 123 of file bulletWheel.h.

## ◆ get_wheels_damping_relaxation

PN_stdfloat BulletWheel::get_wheels_damping_relaxation

Returns the damping applied to the relaxing suspension.

Definition at line 124 of file bulletWheel.h.

## ◆ get_wheels_suspension_force

PN_stdfloat BulletWheel::get_wheels_suspension_force

Definition at line 133 of file bulletWheel.h.

## ◆ get_world_transform

LMatrix4 BulletWheel::get_world_transform

Definition at line 139 of file bulletWheel.h.

## ◆ is_front_wheel

bool BulletWheel::is_front_wheel

Determines if a wheel is steerable.

Definition at line 140 of file bulletWheel.h.

## ◆ set_brake

void BulletWheel::set_brake

Definition at line 131 of file bulletWheel.h.

## ◆ set_chassis_connection_point_cs

void BulletWheel::set_chassis_connection_point_cs

Sets the point where the wheel is connected to the chassis.

Definition at line 136 of file bulletWheel.h.

## ◆ set_clipped_inv_connection_point_cs

void BulletWheel::set_clipped_inv_connection_point_cs

Definition at line 135 of file bulletWheel.h.

## ◆ set_delta_rotation

void BulletWheel::set_delta_rotation

Definition at line 129 of file bulletWheel.h.

## ◆ set_engine_force

void BulletWheel::set_engine_force

Defines how much force should be used to rotate the wheel.

Definition at line 130 of file bulletWheel.h.

## ◆ set_friction_slip

void BulletWheel::set_friction_slip

Sets the slipperyness of the tyre.

Definition at line 121 of file bulletWheel.h.

## ◆ set_front_wheel

void BulletWheel::set_front_wheel

Sets if the wheel is steerable.

Definition at line 140 of file bulletWheel.h.

## ◆ set_max_suspension_force

void BulletWheel::set_max_suspension_force

Sets the maximum suspension force the wheel can handle.

Definition at line 122 of file bulletWheel.h.

## ◆ set_max_suspension_travel_cm

void BulletWheel::set_max_suspension_travel_cm

Sets the maximum distance the suspension can travel out of the resting position in centimeters.

Definition at line 120 of file bulletWheel.h.

## ◆ set_node

void BulletWheel::set_node

Sets the PandaNode which representates the visual appearance of this wheel.

Definition at line 141 of file bulletWheel.h.

## ◆ set_roll_influence

void BulletWheel::set_roll_influence

Defines a scaling factor for roll forces that affect the chassis.

0.0 means no roll - the chassis won't ever flip over - while 1.0 means original physical behaviour. Basically, this allows moving the center of mass up and down.

Definition at line 125 of file bulletWheel.h.

## ◆ set_rotation

void BulletWheel::set_rotation

Definition at line 128 of file bulletWheel.h.

## ◆ set_skid_info

void BulletWheel::set_skid_info

Definition at line 132 of file bulletWheel.h.

## ◆ set_steering

void BulletWheel::set_steering

Sets the steering angle.

Definition at line 127 of file bulletWheel.h.

## ◆ set_suspension_relative_velocity

void BulletWheel::set_suspension_relative_velocity

Definition at line 134 of file bulletWheel.h.

## ◆ set_suspension_stiffness

void BulletWheel::set_suspension_stiffness

Sets how stiff the suspension shall be.

Definition at line 119 of file bulletWheel.h.

## ◆ set_wheel_axle_cs

void BulletWheel::set_wheel_axle_cs

Determines the wheel axle normal vector.

Definition at line 138 of file bulletWheel.h.

## ◆ set_wheel_direction_cs

void BulletWheel::set_wheel_direction_cs

Sets the wheel's forward vector.

(Most likely orthogonal to the axle vector.)

Definition at line 137 of file bulletWheel.h.

## ◆ set_wheel_radius

void BulletWheel::set_wheel_radius

Sets the wheel radius.

Definition at line 126 of file bulletWheel.h.

## ◆ set_wheels_damping_compression

void BulletWheel::set_wheels_damping_compression

Sets the damping forces applied when the suspension gets compressed.

Definition at line 123 of file bulletWheel.h.

## ◆ set_wheels_damping_relaxation

void BulletWheel::set_wheels_damping_relaxation

Sets the damping forces applied when the suspension relaxes.

Definition at line 124 of file bulletWheel.h.

## ◆ set_wheels_suspension_force

void BulletWheel::set_wheels_suspension_force

Definition at line 133 of file bulletWheel.h.

## ◆ set_world_transform

void BulletWheel::set_world_transform

Definition at line 139 of file bulletWheel.h.

The documentation for this class was generated from the following files:

- panda/src/bullet/bulletWheel.h
- panda/src/bullet/bulletWheel.cxx
- panda/src/bullet/bulletWheel.I